// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import { QueryHandler } from "../../../../../../core/decorator/QueryHandlerDecorator";
import { RPCQueryAdapter } from "../../../../../../port/out/rpc/RPCQueryAdapter";
import { GetTokenBySaltQuery, GetTokenBySaltQueryResponse } from "./GetTokenBySaltQuery";
import AccountService from "../../../../../service/account/AccountService";
import { GetTokenBySaltQueryError } from "./error/GetTokenBySaltQueryError";
let GetTokenBySaltQueryHandler = class GetTokenBySaltQueryHandler {
    queryAdapter;
    accountService;
    constructor(queryAdapter, accountService) {
        this.queryAdapter = queryAdapter;
        this.accountService = accountService;
    }
    async execute(query) {
        try {
            const { salt, factory } = query;
            const factoryEvmAddress = await this.accountService.getAccountEvmAddress(factory);
            const token = await this.queryAdapter.getTrexTokenBySalt(factoryEvmAddress, salt);
            return Promise.resolve(new GetTokenBySaltQueryResponse(token));
        }
        catch (error) {
            throw new GetTokenBySaltQueryError(error);
        }
    }
};
GetTokenBySaltQueryHandler = __decorate([
    QueryHandler(GetTokenBySaltQuery),
    __param(0, lazyInject(RPCQueryAdapter)),
    __param(1, lazyInject(AccountService)),
    __metadata("design:paramtypes", [RPCQueryAdapter,
        AccountService])
], GetTokenBySaltQueryHandler);
export { GetTokenBySaltQueryHandler };
